/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-lizi-1.0.2-1raring-20150330-0935/msg/lizi_pan_tilt.msg
 *
 */


#ifndef LIZI_MESSAGE_LIZI_PAN_TILT_H
#define LIZI_MESSAGE_LIZI_PAN_TILT_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace lizi
{
template <class ContainerAllocator>
struct lizi_pan_tilt_
{
  typedef lizi_pan_tilt_<ContainerAllocator> Type;

  lizi_pan_tilt_()
    : pan_angle(0.0)
    , tilt_angle(0.0)  {
    }
  lizi_pan_tilt_(const ContainerAllocator& _alloc)
    : pan_angle(0.0)
    , tilt_angle(0.0)  {
    }



   typedef float _pan_angle_type;
  _pan_angle_type pan_angle;

   typedef float _tilt_angle_type;
  _tilt_angle_type tilt_angle;




  typedef boost::shared_ptr< ::lizi::lizi_pan_tilt_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::lizi::lizi_pan_tilt_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct lizi_pan_tilt_

typedef ::lizi::lizi_pan_tilt_<std::allocator<void> > lizi_pan_tilt;

typedef boost::shared_ptr< ::lizi::lizi_pan_tilt > lizi_pan_tiltPtr;
typedef boost::shared_ptr< ::lizi::lizi_pan_tilt const> lizi_pan_tiltConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::lizi::lizi_pan_tilt_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::lizi::lizi_pan_tilt_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace lizi

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'lizi': ['/tmp/buildd/ros-hydro-lizi-1.0.2-1raring-20150330-0935/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::lizi::lizi_pan_tilt_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::lizi::lizi_pan_tilt_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::lizi::lizi_pan_tilt_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::lizi::lizi_pan_tilt_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::lizi::lizi_pan_tilt_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::lizi::lizi_pan_tilt_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::lizi::lizi_pan_tilt_<ContainerAllocator> >
{
  static const char* value()
  {
    return "f191de4d1f51ebd5f8f3b12305019bf6";
  }

  static const char* value(const ::lizi::lizi_pan_tilt_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xf191de4d1f51ebd5ULL;
  static const uint64_t static_value2 = 0xf8f3b12305019bf6ULL;
};

template<class ContainerAllocator>
struct DataType< ::lizi::lizi_pan_tilt_<ContainerAllocator> >
{
  static const char* value()
  {
    return "lizi/lizi_pan_tilt";
  }

  static const char* value(const ::lizi::lizi_pan_tilt_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::lizi::lizi_pan_tilt_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float32 pan_angle\n\
float32 tilt_angle\n\
\n\
\n\
";
  }

  static const char* value(const ::lizi::lizi_pan_tilt_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::lizi::lizi_pan_tilt_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.pan_angle);
      stream.next(m.tilt_angle);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct lizi_pan_tilt_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::lizi::lizi_pan_tilt_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::lizi::lizi_pan_tilt_<ContainerAllocator>& v)
  {
    s << indent << "pan_angle: ";
    Printer<float>::stream(s, indent + "  ", v.pan_angle);
    s << indent << "tilt_angle: ";
    Printer<float>::stream(s, indent + "  ", v.tilt_angle);
  }
};

} // namespace message_operations
} // namespace ros

#endif // LIZI_MESSAGE_LIZI_PAN_TILT_H
